    001/*
    002 *  Licensed to the Apache Software Foundation (ASF) under one or more
    003 *  contributor license agreements.  See the NOTICE file distributed with
    004 *  this work for additional information regarding copyright ownership.
    005 *  The ASF licenses this file to You under the Apache License, Version 2.0
    006 *  (the "License"); you may not use this file except in compliance with
    007 *  the License.  You may obtain a copy of the License at
    008 *
    009 *      http://www.apache.org/licenses/LICENSE-2.0
    010 *
    011 *  Unless required by applicable law or agreed to in writing, software
    012 *  distributed under the License is distributed on an "AS IS" BASIS,
    013 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    014 *  See the License for the specific language governing permissions and
    015 *  limitations under the License.
    016 *
    017 */
    018package org.apache.commons.compress.archivers.zip;
    019
    020import org.apache.commons.compress.parallel.FileBasedScatterGatherBackingStore;
    021import org.apache.commons.compress.parallel.InputStreamSupplier;
    022import org.apache.commons.compress.parallel.ScatterGatherBackingStore;
    023import org.apache.commons.compress.parallel.ScatterGatherBackingStoreSupplier;
    024
    025import java.io.File;
    026import java.io.IOException;
    027import java.util.ArrayList;
    028import java.util.List;
    029import java.util.concurrent.Callable;
    030import java.util.concurrent.ExecutionException;
    031import java.util.concurrent.ExecutorService;
    032import java.util.concurrent.Executors;
    033import java.util.concurrent.Future;
    034import java.util.concurrent.TimeUnit;
    035import java.util.concurrent.atomic.AtomicInteger;
    036import java.util.zip.Deflater;
    037
    038import static java.util.Collections.synchronizedList;
    039import static org.apache.commons.compress.archivers.zip.ZipArchiveEntryRequest.createZipArchiveEntryRequest;
    040
    041/**
    042 * Creates a zip in parallel by using multiple threadlocal {@link ScatterZipOutputStream} instances.
    043 * <p>
    044 * Note that this class generally makes no guarantees about the order of things written to
    045 * the output file. Things that need to come in a specific order (manifests, directories)
    046 * must be handled by the client of this class, usually by writing these things to the
    047 * {@link ZipArchiveOutputStream} <em>before</em> calling {@link #writeTo writeTo} on this class.</p>
    048 * <p>
    049 * The client can supply an {@link java.util.concurrent.ExecutorService}, but for reasons of
    050 * memory model consistency, this will be shut down by this class prior to completion.
    051 * </p>
    052 * @since 1.10
    053 */
    054public class ParallelScatterZipCreator {
    055    private final List<ScatterZipOutputStream> streams = synchronizedList(new ArrayList<ScatterZipOutputStream>());
    056    private final ExecutorService es;
    057    private final ScatterGatherBackingStoreSupplier backingStoreSupplier;
    058    private final List<Future<Object>> futures = new ArrayList<>();
    059
    060    private final long startedAt = System.currentTimeMillis();
    061    private long compressionDoneAt = 0;
    062    private long scatterDoneAt;
    063
    064    private static class DefaultBackingStoreSupplier implements ScatterGatherBackingStoreSupplier {
    065        final AtomicInteger storeNum = new AtomicInteger(0);
    066
    067        @Override
    068        public ScatterGatherBackingStore get() throws IOException {
    069            final File tempFile = File.createTempFile("parallelscatter", "n" + storeNum.incrementAndGet());
    070            return new FileBasedScatterGatherBackingStore(tempFile);
    071        }
    072    }
    073
    074    private ScatterZipOutputStream createDeferred(final ScatterGatherBackingStoreSupplier scatterGatherBackingStoreSupplier)
    075            throws IOException {
    076        final ScatterGatherBackingStore bs = scatterGatherBackingStoreSupplier.get();
    077        // lifecycle is bound to the ScatterZipOutputStream returned
    078        final StreamCompressor sc = StreamCompressor.create(Deflater.DEFAULT_COMPRESSION, bs); //NOSONAR
    079        return new ScatterZipOutputStream(bs, sc);
    080    }
    081
    082    private final ThreadLocal<ScatterZipOutputStream> tlScatterStreams = new ThreadLocal<ScatterZipOutputStream>() {
    083        @Override
    084        protected ScatterZipOutputStream initialValue() {
    085            try {
    086                final ScatterZipOutputStream scatterStream = createDeferred(backingStoreSupplier);
    087                streams.add(scatterStream);
    088                return scatterStream;
    089            } catch (final IOException e) {
    090                throw new RuntimeException(e); //NOSONAR
    091            }
    092        }
    093    };
    094
    095    /**
    096     * Create a ParallelScatterZipCreator with default threads, which is set to the number of available
    097     * processors, as defined by {@link java.lang.Runtime#availableProcessors}
    098     */
    099    public ParallelScatterZipCreator() {
    100        this(Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors()));
    101    }
    102
    103    /**
    104     * Create a ParallelScatterZipCreator
    105     *
    106     * @param executorService The executorService to use for parallel scheduling. For technical reasons,
    107     *                        this will be shut down by this class.
    108     */
    109    public ParallelScatterZipCreator(final ExecutorService executorService) {
    110        this(executorService, new DefaultBackingStoreSupplier());
    111    }
    112
    113    /**
    114     * Create a ParallelScatterZipCreator
    115     *
    116     * @param executorService The executorService to use. For technical reasons, this will be shut down
    117     *                        by this class.
    118     * @param backingStoreSupplier The supplier of backing store which shall be used
    119     */
    120    public ParallelScatterZipCreator(final ExecutorService executorService,
    121                                     final ScatterGatherBackingStoreSupplier backingStoreSupplier) {
    122        this.backingStoreSupplier = backingStoreSupplier;
    123        es = executorService;
    124    }
    125
    126    /**
    127     * Adds an archive entry to this archive.
    128     * <p>
    129     * This method is expected to be called from a single client thread
    130     * </p>
    131     *
    132     * @param zipArchiveEntry The entry to add.
    133     * @param source          The source input stream supplier
    134     */
    135
    136    public void addArchiveEntry(final ZipArchiveEntry zipArchiveEntry, final InputStreamSupplier source) {
    137        submit(createCallable(zipArchiveEntry, source));
    138    }
    139
    140    /**
    141     * Adds an archive entry to this archive.
    142     * <p>
    143     * This method is expected to be called from a single client thread
    144     * </p>
    145     *
    146     * @param zipArchiveEntryRequestSupplier Should supply the entry to be added.
    147     * @since 1.13
    148     */
    149    public void addArchiveEntry(final ZipArchiveEntryRequestSupplier zipArchiveEntryRequestSupplier) {
    150        submit(createCallable(zipArchiveEntryRequestSupplier));
    151    }
    152
    153    /**
    154     * Submit a callable for compression.
    155     *
    156     * @see ParallelScatterZipCreator#createCallable for details of if/when to use this.
    157     *
    158     * @param callable The callable to run, created by {@link #createCallable createCallable}, possibly wrapped by caller.
    159     */
    160    public final void submit(final Callable<Object> callable) {
    161        futures.add(es.submit(callable));
    162    }
    163
    164    /**
    165     * Create a callable that will compress the given archive entry.
    166     *
    167     * <p>This method is expected to be called from a single client thread.</p>
    168     *
    169     * Consider using {@link #addArchiveEntry addArchiveEntry}, which wraps this method and {@link #submit submit}.
    170     * The most common use case for using {@link #createCallable createCallable} and {@link #submit submit} from a
    171     * client is if you want to wrap the callable in something that can be prioritized by the supplied
    172     * {@link ExecutorService}, for instance to process large or slow files first.
    173     * Since the creation of the {@link ExecutorService} is handled by the client, all of this is up to the client.
    174     *
    175     * @param zipArchiveEntry The entry to add.
    176     * @param source          The source input stream supplier
    177     * @return A callable that should subsequently passed to #submit, possibly in a wrapped/adapted from. The
    178     * value of this callable is not used, but any exceptions happening inside the compression
    179     * will be propagated through the callable.
    180     */
    181
    182    public final Callable<Object> createCallable(final ZipArchiveEntry zipArchiveEntry, final InputStreamSupplier source) {
    183        final int method = zipArchiveEntry.getMethod();
    184        if (method == ZipMethod.UNKNOWN_CODE) {
    185            throw new IllegalArgumentException("Method must be set on zipArchiveEntry: " + zipArchiveEntry);
    186        }
    187        final ZipArchiveEntryRequest zipArchiveEntryRequest = createZipArchiveEntryRequest(zipArchiveEntry, source);
    188        return new Callable<Object>() {
    189            @Override
    190            public Object call() throws Exception {
    191                tlScatterStreams.get().addArchiveEntry(zipArchiveEntryRequest);
    192                return null;
    193            }
    194        };
    195    }
    196
    197    /**
    198     * Create a callable that will compress archive entry supplied by {@link ZipArchiveEntryRequestSupplier}.
    199     *
    200     * <p>This method is expected to be called from a single client thread.</p>
    201     *
    202     * The same as {@link #createCallable(ZipArchiveEntry, InputStreamSupplier)}, but the archive entry
    203     * to be added is supplied by a {@link ZipArchiveEntryRequestSupplier}.
    204     *
    205     * @see #createCallable(ZipArchiveEntry, InputStreamSupplier)
    206     *
    207     * @param zipArchiveEntryRequestSupplier Should supply the entry to be added.
    208     * @return A callable that should subsequently passed to #submit, possibly in a wrapped/adapted from. The
    209     * value of this callable is not used, but any exceptions happening inside the compression
    210     * will be propagated through the callable.
    211     * @since 1.13
    212     */
    213    public final Callable<Object> createCallable(final ZipArchiveEntryRequestSupplier zipArchiveEntryRequestSupplier) {
    214        return new Callable<Object>() {
    215            @Override
    216            public Object call() throws Exception {
    217                tlScatterStreams.get().addArchiveEntry(zipArchiveEntryRequestSupplier.get());
    218                return null;
    219            }
    220        };
    221    }
    222
    223    /**
    224     * Write the contents this to the target {@link ZipArchiveOutputStream}.
    225     * <p>
    226     * It may be beneficial to write things like directories and manifest files to the targetStream
    227     * before calling this method.
    228     * </p>
    229     *
    230     * @param targetStream The {@link ZipArchiveOutputStream} to receive the contents of the scatter streams
    231     * @throws IOException          If writing fails
    232     * @throws InterruptedException If we get interrupted
    233     * @throws ExecutionException   If something happens in the parallel execution
    234     */
    235    public void writeTo(final ZipArchiveOutputStream targetStream)
    236            throws IOException, InterruptedException, ExecutionException {
    237
    238        // Make sure we catch any exceptions from parallel phase
    239        for (final Future<?> future : futures) {
    240            future.get();
    241        }
    242
    243        es.shutdown();
    244        es.awaitTermination(1000 * 60l, TimeUnit.SECONDS);  // == Infinity. We really *must* wait for this to complete
    245
    246        // It is important that all threads terminate before we go on, ensure happens-before relationship
    247        compressionDoneAt = System.currentTimeMillis();
    248
    249        for (final ScatterZipOutputStream scatterStream : streams) {
    250            scatterStream.writeTo(targetStream);
    251            scatterStream.close();
    252        }
    253
    254        scatterDoneAt = System.currentTimeMillis();
    255    }
    256
    257    /**
    258     * Returns a message describing the overall statistics of the compression run
    259     *
    260     * @return A string
    261     */
    262    public ScatterStatistics getStatisticsMessage() {
    263        return new ScatterStatistics(compressionDoneAt - startedAt, scatterDoneAt - compressionDoneAt);
    264    }
    265}
    266